package cheddar.aadl;

import org.osate.aadl2.NamedElement;
import org.osate.aadl2.instance.ComponentInstance;
import org.osate.xtext.aadl2.properties.util.GetProperties;

import cheddar.adl.Policies;
import cheddar.adl.Resources_Type;
import cheddar.adl.Schedulers_Type;
import cheddar.adl.Tasks_Type;

public class Properties_With_Default_Value {


	public static Policies getPOSIX_Scheduling_Policy(final NamedElement ne) {
		Policies policy = Policies.Sched_Fifo;
		try {
			String s=Cheddar_Properties_Util.getPOSIX_Scheduling_Policy(ne).getName();
			if (s != null) {
				policy = Policies.fromString(s.toLowerCase());
			}
		} catch (Exception e) {
		}
		return policy;
	}

	public static Resources_Type getConcurrencyControlProtocol(final NamedElement ne) {
		Resources_Type rt = Resources_Type.No_Protocol;
		try {
			String s = GetProperties.getConcurrencyControlProtocol(ne);
			if (s != null) {
				if (s.toLowerCase().equals("priority_ceiling")) {
					return Resources_Type.Priority_Ceiling_Protocol;
				} else {
					rt = Resources_Type.fromString(s.toLowerCase());
				}
			}

		} catch (Exception e) {
		}
		return rt;
	}

	public static Tasks_Type getDispatchProtocol(final NamedElement ne) {
		Tasks_Type tt = Tasks_Type.Periodic_Type;
		try {
			String s = GetProperties.getDispatchProtocol(ne).getName();
			if (s != null) {
				tt = Tasks_Type.fromString(s.toLowerCase());
			}
		} catch (Exception e) {
		}
		return tt;
	}

	public static Integer getDispatch_Jitter(final NamedElement ne) {
		Integer jitter = 0;
		try {
			jitter = (int) Cheddar_Properties_Util.getDispatch_JitterinMilliSec(ne);
		} catch (Exception e) {
		}
		return jitter;
	}

	public static Integer getDispatch_Absolute_Time(final NamedElement ne) {
		Integer start_time = 0;
		try {
			start_time = (int) Cheddar_Properties_Util.getDispatch_Absolute_TimeinMilliSec(ne);
		} catch (Exception e) {
		}
		return start_time;
	}

	public static Integer getExecutionTime(final NamedElement ne) {
		Integer execution_time = 0;
		try {
			execution_time = (int) GetProperties.getMaximumComputeExecutionTimeinMs(ne);
		} catch (Exception e) {
		}
		return execution_time;
	}

	public static Integer getDeadline(final NamedElement ne) {
		Integer deadline = 0;
		try {
			deadline = (int) GetProperties.getDeadlineinMilliSec(ne);
		} catch (Exception e) {
		}
		return deadline;
	}

	public static Integer getPeriod(final NamedElement ne) {
		Integer period = 0;
		try {
			period = (int) GetProperties.getPeriodinMS(ne);
		} catch (Exception e) {
		}
		return period;
	}
	public static Integer getPriority(final NamedElement ne) {
		Integer priority = 0;
		try {
			priority = (int) Cheddar_Properties_Util.getFixedPriority(ne);
			priority = (int) GetProperties.getPriority(ne, 0);
		} catch (Exception e) {
		}
		return priority;
	}

	public static Integer getScheduler_Quantum(final NamedElement ne) {
		Integer quantum = 0;
	try {
			quantum = Cheddar_Properties_Util.getScheduler_Quantum(ne);
		} catch (Exception e) {
		}
		return quantum;
	}

	public static String getSource_Text(final NamedElement ne) {
		String source_text = "";
		try {
			source_text = Cheddar_Properties_Util.getSource_Text(ne);
			if (source_text == null) {
				source_text="";
			}
		} catch (Exception e) {
		}
		return source_text;
	}

	public static Schedulers_Type getSchedulingProtocol(ComponentInstance ne) {
		Schedulers_Type protocol = Schedulers_Type.No_Scheduling_Protocol;
		try {
			String s = GetProperties.getSchedulingProtocol(ne);
			if (s != null) {
				protocol = Schedulers_Type.fromString(s.toLowerCase());
			}
		} catch (Exception e) {
		}
		return protocol;
	}

	public static boolean getPreemptive_Scheduler(final NamedElement ne) {
	boolean preemptive = true;
	try {
			preemptive = Cheddar_Properties_Util.getPreemptive_Scheduler(ne);
	} catch (Exception e) {
	}
	return preemptive;
	}

}
