package cheddar.aadl;

import java.util.ArrayList;

import org.osate.aadl2.instance.ComponentInstance;

import cheddar.adl.entities.Critical_Section;
import cheddar.adl.entities.Np_Resource;
import cheddar.adl.entities.PCP_Resource;
import cheddar.adl.entities.PIP_Resource;
import cheddar.adl.types.Priority_Assignement;
import cheddar.exceptions.VariableValueException;

public class Resource_AADL {

	private String resource_name;
	private String resource_procotol;
	ArrayList<Critical_AADL> criticals;

	public void To_Thread_Critical_Section(cheddar.adl.entities.System result, ComponentInstance component) {
		/*
		 * for (FeatureInstance featureInstance : component.getFeatureInstances()) {
		 * for (ConnectionInstance connection : featureInstance.getDstConnectionInstances()) {
		 * array_critical.add(new Critical_AADL(connection.getSource().getName(), component.getName(),
		 * (int) GetProperties.getMaximumComputeExecutionTimeinMs(component)));
		 * // Getting the dataports
		 * array_dependency_aadl.add(new Dependency_AADL(connection.getFullName(),
		 * GetProperties.getConnectionTiming(connection).getName()));
		 * path = connection.getFullName() + "  "
		 * + GetProperties.getConnectionTiming(connection).getName();
		 * }
		 * }
		 */
	}

	public Resource_AADL(String resource_name, String resource_procotol, Critical_AADL... critical_AADLs) {

		this.resource_name = resource_name;
		this.resource_procotol = resource_procotol;
		this.criticals = new ArrayList<>();
		for (Critical_AADL critical : critical_AADLs) {
			if (critical.getResource_name().equals(this.resource_name)) {
				this.criticals.add(critical);
			}
		}

	}

	public void add_critical(Critical_AADL... critical_aadl) {

		if ((critical_aadl != null) && (critical_aadl.length > 0)) {
			for (Critical_AADL critical : critical_aadl) {
				if (critical.getResource_name().equals(this.resource_name)) {
					this.criticals.add(critical);
				}
			}
		}
	}

	public Resource toCheddarResource(int state, int size, int address, String cpu_name, String address_space_name,
			int priority, Priority_Assignement priority_assignment) throws VariableValueException {

		Resource resource;

		switch (this.resource_procotol) {
		case "Priority_Ceiling":
			resource = new PCP_Resource("id_pcp", this.resource_name, state, size, address, cpu_name,
					address_space_name, priority, priority_assignment, toCritical_Cheddar());
			break;
		case "Priority_Inheritance":

			resource = new PIP_Resource("id_pip", this.resource_name, state, size, address, cpu_name,
					address_space_name, priority, priority_assignment, toCritical_Cheddar());
			break;
		case "None_Specified":
			resource = new Np_Resource("id_np", this.resource_name, state, size, address, cpu_name, address_space_name,
					toCritical_Cheddar());
		default:
			resource = new Np_Resource("id_np", this.resource_name, state, size, address, cpu_name, address_space_name,
					toCritical_Cheddar());
			break;
		}

		return resource;

	}

	private Critical_Section[] toCritical_Cheddar() {

		Critical_Section[] critical_section = new Critical_Section[this.criticals.size()];

		for (int i = 0; i < this.criticals.size(); i++) {
			critical_section[i] = this.criticals.get(i).toCheddarCriticalSection();
		}

		return critical_section;

	}

	public ArrayList<Critical_AADL> getCritical() {
		return this.criticals;
	}

	@Override
	public String toString() {
		return "Resource_AADL [resource_name=" + resource_name + ", resource_procotol=" + resource_procotol
				+ ", criticals=" + criticals.toString() + "]";
	}


}
